
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>何为程序员思维 / iVAN</title>

    <meta name="description" content="何为程序员思维 看到这个题目,我想起了很多很多........... 首先,我说明我为什么要写这篇文章了. 一个原因是逸惋惜峥嵘岁月岁月稠,当初读大学的时候,学习计算机技术的课程,我过多的走向了两种极端的状况.一种情况,我愿意把他归结于本末倒置,例如我学习&lt;C++面向对象程序设计&gt;的时候,更多的是研究C++的语法,却忽略了面向对象的思想,到头来,C++语法学会了,但是最重要的面向对象却没有理解,也不知道他能够真正的做些什么.另一个情况,我把它理解为目标很宏大,理解很困难,例如,我学习软件过程的时候, ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">何为程序员思维</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>　看到这个题目，我想起了很多很多...........</p>
<p>　　首先，我说明我为什么要写这篇文章了。</p>
<p>　　一个原因是逸惋惜峥嵘岁月岁月稠，当初读大学的时候，学习计算机技术的课程，我过多的走向了两种极端的状况。一种情况，我愿意把他归结于本末倒置，例如我学习《C++面向对象程序设计》的时候，更多的是研究C++的语法，却忽略了面向对象的思想，到头来，C++语法学会了，但是最重要的面向对象却没有理解，也不知道他能够真正的做些什么。另一个情况，我把它理解为目标很宏大，理解很困难，例如，我学习软件过程的时候，开始，课程上就劈头盖脑的来一堆概念，然而，很难理解，最后也失去了学习该 课程的兴趣，后来，随着自己阅历增长，经验的增加， 发现这些知识是非常重要的，只是但是由于知识的限制，没有融会贯通罢了。</p>
<p>　　另外一个原因，我们和他人讨论写的代码时候，总是会从某某的口中听到，你这源代码写的——耦合性太大了，可是，这总是一种不欢而散争论，你凭什么我的耦合性太大，是啊，凭什么说我的耦合性，更多是种感觉，到底怎么样才能判断高内聚低耦合，怎么样写出来高内聚低耦合代码了。</p>
<p>　　还有一 个原因。和上面的原因有点类似，在编程中接触到的很多同事。或者同样是编程的人。我发现他们的能力参差不齐。但是，你会有这样的感受，有些人写了两三年的代码会比一个写十几年代码，更加的简洁，更加的优雅。</p>
<p>　　总结一下上面的原因就是，在我们的编程实践中，我们需要找到一种思维框架来帮助我们设计和解释我们的程序。这个东西就是要讨论的程序员思维。</p>
<p>　　我们下面篇幅就解决这三个问题。</p>
<p>　　程序员思维是什么？<br />
程序员思维从哪里来？<br />
程序员思维到哪里去？<br />
好吧，这是三个终极的问题。没有标准答案，也没有什么不标准的答案。我只是试图给出自己的一个思考的总结。</p>
<p>　　再解释程序员思维是什么问题这个问题是什么时候，我们先用类比法看一下什么是程序员思维。</p>
<p>　　类比法，是个好方法啊，就像字典中的同义词解析一样。我们就类比生活中的一些例子罢了，来解释什么是程序员思维。有些人，说编程就像解题，一个题干出出来了，我们需要利用所掌握的知识，一步步，井井有条的解决出来。而编程了，则是根据客户的一个需求，利用自己技能把其变成计算机软件，来帮助解决现实生活中的问题。有些人，说编程就像操作机器，你像一个司机，你操作方向盘让车向左走，他不会向右左。我们编程也是同样的道理，你输入一条加法指令，计算机也不会帮你做减法。有些人，说编程就像作家，作家，是将冰冷冷文字赋予了生命，来卖钱。程序员，是将毫无生气的一些指令，变成那好玩游戏，哪方便的app。这些，都是很形象的类比。我们这里套用马克思*韦伯在《新教理论与资本主义》中首次提出了一个概念能够很好的解释上面列举的事情的共性——工具理性。所谓“工具理性”，就是通过实践的途径确认工具（手段）的有用性，从而追求事物的最大功效，为人的某种功利的实现服务。工具理性是通过精确计算功利的方法最有效达至目的的理性,是一种以工具崇拜和技术主义为生存目标的价值观,所以“工具理性”又叫“功效理性”或者说“效率理性”的定义。可以将程序员思维，定义为是在理性思维的框架下，利用相应工具，来解决相应实际的问题。</p>
<p>　　再回答程序员思维从哪里来，这个问题时候，我们回顾了计算机语言历史：</p>
<p>　　1940之前</p>
<p>　　第一个编程语言比现代的计算机还早诞生。首先，这种语言是种编码(en:code)。 于1801年发明的提花织布机(或称甲卡提花织布机，英文：en:Jacquard loom)，运用打孔卡上的坑洞来代表缝纫织布机的手臂动作，以便自动化产生装饰的图案。 Ada Lovelace在1842年至1843年间花费了九个月，将意大利数学家Luigi Menabrea关于查尔斯·巴贝奇新发表机器分析机的回忆录翻译完成。她于那篇文章后面附加了一个用分析机计算伯努利数方法的细节，被部分历史学家认为是世界上第一个电脑程序。这个故事我们上面也说过。 Herman Hollerith在观察列车长对乘客票根在特定位置打洞的方式后，意识到他可以把资讯编码记载到打孔卡上，随后根据这项发现使用打孔卡来编码并纪录1890年的人口统计资料。 第一个严格意义上的计算机程式码是针对他们的应用面设计的。在20世纪的前十年主要是用十进制来算数，后来人们发现不只是用文字，也可以用数字来表现逻辑。举例来说，阿隆佐·邱奇曾以公式化(formulaic)的方式表达λ演算。图灵机是一种纸带标记(tape-marking)机器(就像电话公司用的那种)操作方法抽象化后的集合。图灵机这种透过有限数字(finite number)呈现机器的方式，奠定了程式如同冯·诺伊曼结构计算机中的资料一样地储存的基础。但不同于λ演算，图灵机的程式码并没有办法成为高阶编程语言的基石，这是是因为它主要的用途是分析算法的复杂度。 就像许多历史上的”第一次”一样，第一个现代编程语言也很难界定。最一开始是因为硬件限制而限定了语言，打孔卡允许80行(column)的长度，但某几行必须用来记录卡片的顺序。FORTRAN则纳入了一些与英文字词相同的关键字，像是”IF”、”GOTO”(原字词为go to)，以及”CONTINUE”。之后采用磁鼓(magnetic drum)作为内存使用，也代表计算机程式也必须插入(interleave)到磁鼓的转动(rotation)中。和现今比较起来，这也让编程语言必须更加依赖硬件(hardware-dependent)。 对部分的人认为必须在”编程语言”的状态确立之前，根据能力(power)以及可读性(human-readability)的程度来决定历史上第一个编程语言是什么语言。提花织布机和查尔斯·巴贝奇所制作的差分机(en:Difference Engine)都具备在大量限制下，简单描述机器应执行行为的语言。也有种并非设计给人类运用的受限特定领域语言(en:domain-specific language)，是将打孔卡运用到自动演奏钢琴(en:player piano)上。</p>
<p>　　1940年代<br />
最早被确认的现代化、电力启动(electrically powered)的计算机约在1940年代被创造出来。程式设计师在有限的速度及内存容量限制之下，撰写人工调整(hand tuned)过的组合语言程式。而且很快就发现到使用组合语言的这种撰写方式需要花费大量的脑力(intellectual effort)而且很容易出错(error-prone)。 Konrad Zuse于1948年发表了他所设计的Plankalkül编程语言的论文[1]。但是在他有生之年却未能将该语言实作，而他原本的贡献也被其他的发展所孤立。 在这段期间被开发出来的重要语言包括有：</p>
<p>　　1943 – Plankalkül (Konrad Zuse)<br />
1943 – ENIAC coding system<br />
1949 – C-10<br />
1950与1960年代<br />
有三个现代编程语言于1950年代被设计出来，这三者所衍生的语言直到今日仍旧广泛地被采用：</p>
<p>　　Fortran (1955)，名称取自”FORmula TRANslator”(公式翻译器)，由约翰·巴科斯等人所发明；<br />
LISP，名称取自”LISt Processor”(列举处理器)，由约翰·麦卡锡等人所发明；<br />
COBOL，名称取自”COmmon Business Oriented Language”(通用商业导向语言)，由被葛丽丝·霍普深刻影响的Short Range Committee所发明。<br />
另一个1950年代晚期的里程碑是由美国与欧洲计算机学者针对”算法的新语言”所组成的委员会出版的ALGOL 60报告(名称取自”ALGOrithmic Language”(算法语言))。这份报告强化了当时许多关于计算的想法，并提出了两个语言上的创新功能：</p>
<p>　　巢状区块结构：可以将有意义的程式码片段群组成一个区块(block)，而非转成分散且特定命名的程序。也就是我们所熟悉的模块化设计。<br />
词汇范围(lexical scoping)：区块可以有区块外部无法透过名称存取，属于区块本身的变量、程序以及函式。就是我们所熟悉的作用域。<br />
另一个创新则是关于语言的描述方式：一种名为巴科斯-诺尔范式 (BNF)的数学化精确符号被用于描述语言的语法。之后的编程语言几乎全部都采用类似BNF的方式来描述程式　　语法中上下文无关的部份。BNF主要使用在了Algol 60的设计上面。而Algol 60对之后语言的设计上带来了特殊的影响，在其他部分的语言设计中这种设计思想很快的就被广泛采用。并且后续为了开发Algol的扩充子集合，设计了一个名为Burroughs(en:Burroughs large systems)的大型系统。而延续Algol的关键构想所产生的成果就是ALGOL 68：</p>
<p>　　语法跟语意变的更加正交(orthogonal)<br />
采用匿名的历程(routines)<br />
采用高阶(higher-order)功能的递回式输入(typing)系统等等。<br />
整个语言及语意的部分都透过为了描述语言而特别设计的Van Wijngaarden grammar来进行正式的定义，而不仅止于上下文无关的部份。Algol 68一些较少被使用到的语言功能(如同步与并列区块)、语法捷径的复杂系统，以及型态自动强制转换(coercions)，使得实作者兴趣缺缺，也让Algol 68获得了很难用(diffcult)的名声。尼克劳斯·维尔特就干脆离开该设计委员会，另外在开发出更简单的Pascal语言。 在这段期间被开发出来的重要语言包括有：</p>
<p>　　1951 – Regional Assembly Language<br />
1952 – Autocode<br />
1954 – FORTRAN<br />
1954 – IPL (LISP的先驱)<br />
1955 – FLOW-MATIC (COBOL的先驱)<br />
1957 – COMTRAN (COBOL的先驱)<br />
1958 – LISP　　<br />
1958 – ALGOL 58<br />
1959 – FACT (COBOL的先驱)<br />
1959 – COBOL<br />
1962 – APL<br />
1962 – Simula<br />
1962 – SNOBOL<br />
1963 – CPL (C的先驱)<br />
1964 – BASIC<br />
1964 – PL/I<br />
1967 – BCPL (C的先驱)<br />
1967-1978：确立了基础范式<br />
1960年代晚期至1970年代晚期的期间中，编程语言的发展也有了重大的成果。大多数现在所使用的主要语言范式都是在这段期间中发明的：</p>
<p>　　Simula，于1960年代晚期由奈加特与Dahl以Algol 60超集合的方式发展，同时也是第一个设计支援面向对象进行开发的编程语言。<br />
C，于1969至1973年间由贝尔实验室的研究人员丹尼斯·里奇与肯·汤普逊所开发，是一种早期的系统程式设计(en:system programming)语言。<br />
Smalltalk，于1970年代中期所开发，是一个完全从零开始(ground-up)设计的面向对象编程语言。<br />
Prolog，于1972年由Colmerauer、Roussel，以及Kowalski所设计，是第一个逻辑程式语言。<br />
ML，于1973年由罗宾·米尔纳所发明，是一个基于Lisp所建构的多型(polymorphic)型态系统，同时也是静态型别函数编程语言的先驱。<br />
这些语言都各自演展出自己的家族分支，现今多数现代编程语言的祖先都可以追朔他们其中至少一个以上。 在1960年代以及1970年代中结构化程式设计的优点也带来许多的争议，特别是在程式开发的过程中完全不使用GOTO。这项争议跟语言本身的设计非常有关系：某些语言并没有包含GOTO，这也强迫程式设计师必须结构化地编写程式。尽管这个争议在当时吵翻了天，但几乎所有的程式设计师都同意就算语言本身有提供GOTO的功能，在除了少数罕见的情况下去使用GOTO是种不良的程序风格。结果是之后世代的编程语言设计者发觉到结构化编程语言的争议实在既乏味又令人眼花撩乱。 在这段期间被开发出来的重要语言包括有：</p>
<p>　　1968 – Logo<br />
1970 – Pascal<br />
1970 – Forth<br />
1972 – C语言<br />
1972 – Smalltalk<br />
1972 – Prolog<br />
1973 – ML<br />
1975 – Scheme<br />
1978 – SQL (起先只是一种查询语言，扩充之后也具备了程式结构)<br />
1980年代：增强、模组、效能<br />
1980年代的编程语言与之前相较显得更为强大。C++合并了面向对象以及系统程式设计。美国政府标准化一种名为Ada的系统编程语言并提供给国防承包商使用。日本以及其他地方运用了大量的资金对采用逻辑编程语言结构的第五代语言进行研究。函数编程语言社群则把焦点转移到标准化ML及Lisp身上。这些活动都不是在开发新的范式，而是在将上个世代发明的构想进一步发扬光大。 然而，在语言设计上有个重大的新趋势，就是研究运用模组或大型组织化的程式单元来进行大型系统的开发。Modula、Ada，以及ML都在1980年代发展出值得注意的模组化系统。模组化系统常拘泥于采用泛型程式设计结构：</p>
<p>　　泛型存在(generics being)<br />
本质(essence)<br />
参数化模组(parameterized modules)<br />
尽管没有出现新的主要编程语言范式，许多研究人员仍就扩充之前语言的构想并将它们运用到新的内容上。举例来说，Argus以及Emerald系统的语言配合面向对象语言运用到分散式系统上。 1980年代的编程语言实际情况也有所进展。计算机系统结构中RISC假定硬件应当为编译器设计，而并非为人类设计。借由中央处理器速度增快的帮助，编译技术也越来越进展神速，RISC的进展对高阶语言编译技术发展来不小的贡献。 在这段期间被开发出来的重要语言包括有：</p>
<p>　　1980 – Ada<br />
1983 – C++ (就像有类别的C)<br />
1984 – Common Lisp<br />
1985 – Eiffel<br />
1986 – Erlang<br />
1987 – Perl<br />
1988 – Tcl<br />
1989 – FL (Backus)<br />
1990年代：互联网时代<br />
1990年代未见到有什么重大的创新，大多都是以前构想的重组或变化。这段期间主要在推动的哲学思想是提升程式设计师的生产力。许多”快速应用程式开发” (RAD) 语言也应运而生，这些语言大多都有相应的集成开发环境、垃圾回收等机制，且大多是先前语言的衍生语言。这类型的语言也大多是面向对象的编程语言，包含有Object Pascal、Visual Basic，以及C#。Java则是更加保守的语言，也具备垃圾回收机制。与其他类似语言相比，也受到更多的观注。新的脚本语言则比RAD语言更新更好。这种语言并非直接从其他语言衍生，而且新的语法更加开放地(liberal)与功能契合。虽然脚本语言比RAD语言来的更有生产力，但大多会有因为小程式较为简单，但是大型程式则难以使用脚本语言撰写并维护的顾虑[来源请求]。尽管如此，脚本语言还是网络层面的应用上大放异彩。 在这段期间被开发出来的重要语言包括有：</p>
<p>　　1990 – Haskell<br />
1991 – Python<br />
1991 – Visual Basic<br />
1993 – Ruby<br />
1993 – Lua<br />
1994 – CLOS (part of ANSI Common Lisp)<br />
1995 – Java<br />
1995 – Delphi (Object Pascal)<br />
1995 – JavaScript<br />
1995 – PHP<br />
1997 – REBOL<br />
1999 – D<br />
现今的趋势<br />
编程语言持续在学术及企业两个层面中发展进化，目前的一些趋势包含有：</p>
<p>　　在语言中增加安全性与可靠性验证机制：额外的堆栈检查、资讯流(information flow)控制，以及静态执行绪安全。提供模组化的替代机制：混入(en:mixin)、委派(en:delegates)，以及观点导向。元件导向(component-oriented)软件开发元编程、反射或是存取抽象语法树(en:Abstract syntax tree)更重视分散式及移动式的应用。<br />
与数据库的整合，包含XML及关联式数据库。支援使用Unicode编写程式，所以源代码不会受到ASCII字符集的限制，而可以使用像是非拉丁语系的脚本或延伸标点符号。<br />
图形化使用者接口所使用的XML(XUL、XAML)。在这段期间被开发出来的重要语言包括有：</p>
<p>　　2001 – C#<br />
2001 – Visual Basic .NET<br />
2002 – F#<br />
2003 – Scala<br />
2003 – Factor<br />
2006 – Windows PowerShell<br />
2007 – Clojure<br />
2009 – Go</p>
<p>　　从这些编程语言简史和人们日常需求，我们可以回答这个问题了。所有的程序员思维都是来自于需求两个字。随着对现实信息管理的压力太大的，我们慢慢才有计算机发明。为了，更好的管理计算机，于是便有了编程语言，起初的语言，是面向机器的了，后来随着世人更加理解的角度，就进一步面向过程，为了使人更加理解世界万物，就有了面向对象的语言，综上所述，程序员的思维，从何而来，从世间万物的需求而来，从更好的解决问题的需求而来。</p>
<p>　　有了程序员的思维从何而来的这一个冒解决了，我们就能够很快的回答，程序员思维你要到哪里去了？</p>
<p>　　一切程序员思维的宗旨就是，为了更好的解决问题，更好解决需求，于是在这一光辉思想的引导下了，我们就发明各种各样设计模式，为了使其代码高内聚低耦合，这些都是使其我们程序员花这小的代价来满足最大需求。</p>
<p>　　以上所述，便是我对程序员思维的理解，恳请大家斧正。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 02:02:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%a8%8b%e5%ba%8f/" title="程序">程序</a>, <a href="https://www.iamivan.net/tag/%e4%ba%ba%e7%94%9f/" title="人生">人生</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>何为程序员思维的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/LzJEo4p.html" rel="bookmark">程序员思维定势 优点有时会是缺点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1)机器思维 优秀的程序员最擅长和电脑程序打交道,并通过代码去控制反馈. 而管理需要和人打交道,需要收集人的反馈.电脑是按逻辑来执行的,而人却要复杂很多, 特别是团队中有女性成员,挑战难度就更大. 由于长期和电脑接触,很多程序员缺乏和别人沟通的技巧,或者说情商相对较低. 这在管理上是比较致命的缺点. 2)BUG思维 优秀的程序员追求完美,看自己或者别人代码时第一眼是看什么地方可能有BUG, 管理时如果带着BUG思维,就会只看到别人的不足和错误,而不去表扬其有进步的地方. (完美思维的坏处还有一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPX2gvp.html" rel="bookmark">程序员思维杂谈 - 摘自&OpenCurlyDoubleQuote;javamm工作室&rdquo;QQ群聊天记录</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				某日,老师在课堂上想考考学生们的智商,就问一个男孩: &quot;树上有十 只鸟,开枪打死一只,还剩几只?&quot; 男孩反问:&quot;是无声手枪,还是其他没有声音的枪么?&quot; &quot;不是.&quot; &quot;枪声有多大?&quot; &quot;80~100分贝.&quot; &quot;那就是说会震的耳朵疼?&quot; &quot;是.&quot; &quot;在这个城市里打鸟犯不犯法?&quot; '不犯.&quot; &quot;您确定那只鸟真的被打死啦?&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmRej3z.html" rel="bookmark">程序员思维修炼：从新手到专家的5个阶段</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阶段1:新手 Novices need recipes ---新手需要指令清单. 新手在该技能领域经验很少或者根本没有经验.这里提到的经验,指的是通过实施这项技术促进了思维的改变.举个反例,可能一个开发人员声称拥有十年的经验,但实际上只有一年的经验重复了九次,那么这就不算是经验. 新手非常在乎他们能否成功,没有太多经验指导他们,他们不知道自己的行为是对是错.新手不是特别想要学习,他们只是想实现一个立竿见影的目标.他们不知道如何应付错误,所以出错的时候,他们非常容易慌乱. 但是,如果给新手提供与情			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VzwmOM6.html" rel="bookmark">很认真的聊一聊程序员的自我修养</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天谈一谈,程序员提高自我修养是为了什么?     程序写的好有人崇拜,有妹子喜欢?还是到博客.论坛.社区发表文章进行分享获得成就?我想这是少数人的追求,也是更高的追求,在这之前 我认为,在中国,程序员提高自我修养的目的,是为了 1.更好的融入工作,减少困难,增加成就 2.稳步的提升能力,提高收入,达成财务自由 2.站在更高的层面看待自己的学习和工作,树立更加适合的人生观价值观,家庭幸福,生活愉快 说的更通俗一点,就是用更加合理的方式和方法,赚取到更多的收入   说了这么多废话,进入正题 何为程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Qn9Pp.html" rel="bookmark">程序员内部培训与个人发展杂谈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 文中的培训均指代内部技术培训 本文是对&lt;如何优化程序员的内部培训&gt;的补充,但不需要前置阅读,可以读完本文再回过头来看看.http://blog.csdn.net/hursing/article/details/50147549 例子是针对iOS.Android客户端开发的,但不影响前后端的同学理解. 培训的发展过程 培训的内容是技术知识,要了解培训的发展,首先要知道技术的发展.技术从无到有再到成为热门,相关的知识也需要不断积累的过程,这个过程会滞后于技术本身.可以认为,技术需要时间被认可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1lLw3b.html" rel="bookmark">怎样成为一个优秀的程序员？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				还记得研发频道此前发表过的一篇&lt;白班程序员 VS. 夜猫子程序员&gt;吗?在这个世界上有两种程序员,我们称之为:Day Programmers(白班程序员)和Night Programmers(夜猫子程序员).本文我们将探讨优秀程序员和一般程序员有哪些差别,看看您是属于那一种?来自知乎网上的大牛们各抒己见,一起来看下他们是如何区分的. 创业者 郭凛:如果纯以编码能力来看,可分为五类 1. 拷贝型 拷贝型选手就是传说中的&quot;代码拷贝员&quot;了,他们对实现功能几乎没有思路,所作的事情就是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4Nl6LM.html" rel="bookmark">&OpenCurlyDoubleQuote;菜鸟&rdquo;程序员和&OpenCurlyDoubleQuote;大神&rdquo;程序员差距在哪里</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&quot;菜鸟&quot;和&quot;大神&quot; 刚刚走出就业的程序员,技术是刚刚起步的基点.那下面我们就聊一聊有关技术 的东西.首先请您先想想这几个问题.现在社会上有很多程序员,CSDN就是我们程序员的家,那您是否可想过程序员为什么会有不同的水平?你又是哪一类的程 序员?&quot;菜鸟&quot;程序员和&quot;大神&quot;程序员差在哪里?真是差在技术上了吗?那不是差在技术上那差在了哪里? 上面很多一连串的问题,没有把你搞晕吧!那就听我一一给您分析这个问题背后的答案.确切的说程序员分			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyelnvM.html" rel="bookmark">全国各地的程序员特点分析&comma;搞笑幽默--快来对号入座</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.东北的程序员不但技术好,并且普遍长的帅 2.北京的程序员口才最好,谈架构设计产品营销管理能把你忽悠上天 3.天津的程序员不但程序写得好,还会说相声 4.湖北的程序员最聪明,编程实力超过其他省的程序员 5.湖南的程序员泡妞把妹功底了得,公司的mm基本都围着湖南程序员转,他们是其他省份男程序员的公敌 6.山东程序员踏实努力,善于突击,实力可以比美湖北程序员,正所谓:&quot;要rush请找山东和湖北程序员&quot; 7.上海程序员国际范儿,Geek流 8.陕西程序员实力了得,并且有股摇滚颓废文艺范儿			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx2VVjz.html" rel="bookmark">程序员喜欢什么样的产品经理？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序员和产品经理协作.沟通矛盾是一个永恒的话题.因为两者的知识体系和思维结构不一样,关注的重点不一样,所以在协同工作过程中,难免会出现一些分歧和摩擦,出现互相埋怨和吐槽的情况. 我认为,程序员和产品经理之间的健康关系应该是基于信任.尊重和理解以及同一利益共同体的,脱离了这一前提,高效的协作就成了空谈. 那产品经理在日常的工作过程中,与程序员要保持高度默契,形成健康的协作关系,需要注意哪些方面呢?今天结合我曾经在两个角色之间完成过转换的经历,谈谈自己的理解,一家之言,欢迎拍砖. 平等.尊重与理解是			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBgwOM.html" rel="bookmark" class="title">Photoshop制作一根香烟</a>
					<div>
						香烟构成非常简单,也非常适合新手练习.重点:学习一些组合图形的绘制方法;用图层样式来增加质感;细节部分的简单刻画等. 最终效果 1.新建大小自定文档,背景填充暗灰色.新建图层,没用矩形工具,椭圆工具画 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZj9Yz.html" rel="bookmark" class="title">使用jQuery，第1部分：将桌面应用程序引入浏览器</a>
					<div>
						本文配套源码 简介 jQuery逐渐从其他JavaScript库选择中脱颖而出,并且成为Web开发人员的最佳选择.它迅速成为希望简化客户端开发和快速高效地创建富Internet应用程序(RIA)的程序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYXjKb.html" rel="bookmark" class="title">当下最热门的网页设计趋势总结</a>
					<div>
						  技术的革新带动了设计行业的的迅猛发展,这使得设计师和开发者有了更广阔的的探索天地.而网页设计也越发不再那么循规蹈矩,许多团队和公司都做了很多思考和创意.所以在我们适应着现代设计潮流的同时,不妨也来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7nGAM.html" rel="bookmark" class="title">jQuery Validate 验证&comma;校验规则写在控件中的具体实例</a>
					<div>
						 本篇文章主要是对jQuery Validate 验证,校验规则写在控件中的具体实例进行了介绍,需要的朋友可以过来参考下,希望对大家有所帮助 将校验规则写到控件中    代码如下: &lt;scrip ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGq5Wp.html" rel="bookmark" class="title">Photoshop制作一个漂亮的金色元宝</a>
					<div>
						  制作元宝之前,需要自己去网上搜集一些好看的元宝素材;找出自己喜欢的款式,再了解清楚构造;然后按照分解图慢慢去刻画即可. 最终效果 &lt;点小图查看大图&gt; 1.新建一个1000 * 700像 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArV42p.html" rel="bookmark" class="title">Photoshop通道应用：详细解析计算法的应用</a>
					<div>
						  因为好几位朋友给我打电话,反映严格按照我提供的混合模式(正片叠底)和数据操作(不透明度45%),结果对此幅外国MM做出来的效果看起来非常差,甚至还不如直接&quot;去色&quot;的效果,所以补 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGL08p.html" rel="bookmark" class="title">U盘NTFS、exFAT格式的区别</a>
					<div>
						U盘分区格式相信大家都知道一些了,比较常见的有FAT.FAT32.NTFS和exFAT,FAT已经慢慢被淘汰了,由于单个文件越来越大(如高清电影,大型游戏安装包),超过4G的文件,FAT32格式又不支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WL9jb.html" rel="bookmark" class="title">Mac版如何使用PP助手导入音乐</a>
					<div>
						  操作方法: 方法一:通过PP助手在线下载 一,安装好PP助手Mac后,点击'站点资源栏'的&quot;音乐墙纸铃声&quot;,点击音乐,找到自己喜欢的歌曲后点击 ↓ 下载 二,稍等下载完毕之后, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7ykdb.html" rel="bookmark" class="title">撤消U盘隐藏分区的三大举措</a>
					<div>
						  我们一般地在使用U盘时,都会将U盘分为两个区,并且将其中的一个设置为隐藏分区,从而将重要文件安装在隐藏分区内,让无论是误操作,还是格式化,亦或者是感染病毒的时候,隐藏分区内的内容都安然无恙,不会影 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjOoAb.html" rel="bookmark" class="title">Mac硬盘数据资料读取不了怎么办</a>
					<div>
						  我们有时会发现MAC电脑的硬盘损坏,导致其中储存的资料读取不了,对于这个问题,我们该怎么解决呢?我想一定有很多用户都想知道吧.今天小编就和大家一起分享下这个问题的解决方法. 解决方法: 1. 在i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaExmM.html" rel="bookmark" class="title">运行环境    ＋lda  &quest;</a>
					<div>
						问题描述 运行环境 +lda ? Latent Dirichlet Allocation(LDA) 的lda-0.2.tar运行环境 ps :推荐几个lda入门的资料 请发邮箱:1632648846@ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGoq7b.html" rel="bookmark" class="title">怎么用Java编写一个简单的登录系统？可以注册账号的那种</a>
					<div>
						问题描述 怎么用Java编写一个简单的登录系统?可以注册账号的那种 数据库用的是MySQL,但Java操作方面的不知道怎么入手,求大神指点啊,有实例参考就更好了,谢谢 解决方案 import java ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Y1nKM.html" rel="bookmark" class="title">网站优化要避开的五个雷区</a>
					<div>
						新站优化雷区一:网站标题和版式经常改动 对于新站来说,网站的权重很低甚至还在搜索引擎的考察期.如果这个时间对网站标题和版式频繁改动,会使得搜索引擎认为你的网站还没有完成,那么搜索引擎需要重新认识你的网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmB0Rz.html" rel="bookmark" class="title">新浪作出的种种尝试，成则翘楚，败则岌岌</a>
					<div>
						微博庞大的流量如同一座难以开垦的金矿,新浪微博商业化,走得艰难而保守. 从新浪获悉,新浪微博全新的广告形式即将推出,但外界尚不清楚它具体的模样.这是继今年4月,新浪微博公布广告平台之后,其在广告模式上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6W4jb.html" rel="bookmark" class="title">请问可以在不预先关机vm情况下，直接点击面板的&OpenCurlyDoubleQuote;重新启动&rdquo;按钮吗？</a>
					<div>
						问题描述 请问可以在不预先关机vm情况下,直接点击面板的&quot;重新启动&quot;按钮吗? 请问可以在不预先关机vm情况下,直接点击面板的&quot;重新启动&quot;按钮吗? 解决方案 您好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPP52lp.html" rel="bookmark" class="title">用cxSelect插件补充一下回显过滤项功能</a>
					<div>
						这个在DJANGO里,最好在过滤之后,让用户知道自己过滤的选择.所以要定位默认值. 1,在HTML文件里显示默认值: &lt;form class=&quot;uk-form&quot; name=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3VP4z.html" rel="bookmark" class="title">认识中国八位域名大咖：玩转域名，积累财富</a>
					<div>
						4月22日,小米公司将原有域名xiaomi.com正式更新为mi.com.对于这一举措,小米科技CEO雷军在微博上表示是为适应小米国际化战略,有消息称小米为购买此域名支付了360万美元,约2000万元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZaZ9b.html" rel="bookmark" class="title">mysql char类型主键做查询、更新条件时遇见怪事了，求大神解答</a>
					<div>
						问题描述 mysql char类型主键做查询.更新条件时遇见怪事了,求大神解答 mysql&gt; desc card_info; +-------------+-----------+------+ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKnmwb.html" rel="bookmark" class="title">AI&lpar;OtterTune&rpar;引波澜 - AI会洗牌数据库行业吗&quest; DBA如何转变思想</a>
					<div>
						标签 PostgreSQL , 机器学习 , AI , 自动优化 , DBA , 科学计算 背景 最近AI的新闻特别多,席卷了围棋圈之后,成为了技术圈和媒体热捧的话题. 今天又一个产品借AI上头条了  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDjZdz.html" rel="bookmark" class="title">详解Java编程中线程的挂起、恢复和终止的方法&lowbar;java</a>
					<div>
						有时,线程的挂起是很有用的.例如,一个独立的线程可以用来显示当日的时间.如果用户不希望用时钟,线程被挂起.在任何情形下,挂起线程是很简单的,一旦挂起,重新启动线程也是一件简单的事. 挂起,终止和恢复线 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd7yPb.html" rel="bookmark" class="title">国务院发文提速IT服务业 将给其带来诸多利好</a>
					<div>
						3月20日,&lt;国务院办公厅关于加快发展服务业若干政策措施的实施意见&gt;(国发[2008]11号,以下简称意见)http://www.aliyun.com/zixun/aggregation/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAZrnM.html" rel="bookmark" class="title">绝对准确：DEDE采集文档审核时修改为当前时间</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 DEDE有一个很不好的地方,在采集 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwmA1M.html" rel="bookmark" class="title">c&num;矩形优化排样</a>
					<div>
						问题描述 急求一个c#写的矩形优化排样系统,有思路也行啊! 解决方案 解决方案二:怎么没人啊?难道没人做过吗?解决方案三:iknow.还需要么					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeorBNM.html" rel="bookmark" class="title">java-Java 中一个类定义的一个静态变量 被另一个类使用时 这个静态变量必须有值吗？</a>
					<div>
						问题描述 Java 中一个类定义的一个静态变量 被另一个类使用时 这个静态变量必须有值吗? Java 中一个类定义的一个静态变量 被另一个类使用时 这个静态变量必须有值吗? 解决方案 可以没有值,但建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22d2kb.html" rel="bookmark" class="title">亚马逊高管披露 包邮会员增长仍然迅猛</a>
					<div>
						BI中文站 7月25日报道 和一般的购物网站相比,亚马逊最大特点,是每年收费99美元的包邮会员制度Prime.此前,年费从79美元上涨到99美元之后,业界怀疑,会不会导致用户兴趣大减.不过亚马逊高管周 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqNByb.html" rel="bookmark" class="title">雅虎是否会成为NPE？</a>
					<div>
						伴随雅虎出售互联网核心业务,雅虎未来的定位正成为人们关注的重要问题. 2016年5月,梅耶尔同意了对冲基金Starboard Value LP的要求,其CEO Jeffrey Smith 和他的三名副 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYX1R9b.html" rel="bookmark" class="title">云计算与SOA：更多的是相互提携</a>
					<div>
						云计算从全球金融危机之反而得到了更大的发展空间.像&quot;加入云计算就可以降低成本.加快企业IT实施.迅速扩展.&quot;这样的流行标语几乎无处不在,至少在厂商推销自己的云计算产品时都需要加上这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xwmKb.html" rel="bookmark" class="title">奥林巴斯丑闻调查报告：高管应被清除</a>
					<div>
						新浪科技讯 北京时间12月7日上午消息,负责调查奥林巴斯财务丑闻的第三方小组提供的调查报告称,在财务造假期间无所作为的公司领导者应该被清除.报告说,奥林巴斯前三任董事长和三位高级助理是这起财务丑闻的腐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgv3KM.html" rel="bookmark" class="title">五个步骤告诉你装修公司应该如何去O2O营销</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 一.充分分析业主选择装修的方式: 1.朋友介绍: 在日常生活中,身边的朋友装修的时候找过的装修公司感觉服务还不错,装修的也还漂亮能达到业主的心里逾期;这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GeVLp.html" rel="bookmark" class="title">南海创投黄荔：有限合伙创投项目上市无法律障碍</a>
					<div>
						日前,在湖北省科技厅以及湖北创投界与深圳创投界代表一次座谈会上,有部分与会人士担心,有限合伙制创业投资机构所投资项目在上市环节可能会存在法律障碍,对此,国内第一家有限合伙制创业投资机构--深圳市南海成 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.067 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
